//
//	OrangePekoe Objective Foundation Class
//
#ifndef	__SYSTEM_OBJECT_H__
#define	__SYSTEM_OBJECT_H__

#include <pekoe.h>

namespace System {

	class	Object;
	class	String;

	class	Object {
	protected:
		inline	Object(){}
	public:
		inline	virtual	~Object(){}
		inline	virtual	String	toString();
		inline	virtual	int		get_Hash(){ return (int)(intptr)this; }
		inline	virtual	bool	equals(Object& o){ return &o==this; }
		inline	static	bool	equals(Object& o,Object& p){ return o.equals(p); }
	};

	class	String:public Object {
	protected:
		char*	content;
		int		length;
	public:
		inline	String():content(0),length(0) {}
		inline	String(const char* s):content(0),length(0) { set(s); }
		inline	~String(){ delete content; }
		String&	set(const char* s);
		String&	add(const String& o);
		inline	void	empty(){ set(NULL); }
		inline	String	toString() { return *this; }
		inline	int		get_Length() const { return length; }
		inline	char	operator[](int i) const { return content[i]; }
		inline	const	String&	operator=(const char* s){ set(s); return *this; }
	};

	struct	Point {
		int x,y;
		Point():x(0),y(0) {}
		Point(const Point& point):x(point.x),y(point.y) {}
		Point(int x0,int y0):x(x0),y(y0) {}
		bool	equals(const Point& point){ return x==point.x&&y==point.y; }
		Point&	operator+(const Point& point) { x+=point.x,y+=point.y; return *this; }
		Point&	operator-(const Point& point) { x-=point.x,y-=point.y; return *this; }
	};

	struct	Size {
		int width,height;
		Size() {}
		Size(const Size& sz):width(sz.width),height(sz.height) {}
		Size(int w,int h):width(w),height(h) {}
		bool	equals(const Size& sz){ return width==sz.width&&height==sz.height; }
		void	empty(void){ width=0,height=0; }
		Size&	operator+(const Size& sz){ width+=sz.width,height+=sz.height; return *this; }
		Size&	operator-(const Size& sz){ width+=sz.width,height+=sz.height; return *this; }
	};

	inline	String Object::toString(){ return "[object]"; }

}

#endif
